#include <string.h>

refines class MyString
{
protected:
	Elem* m_Buf;
	int m_Length;
	int m_BufSize;
	int m_MinReallocSize;
public:
	MyString()
		:m_Buf(0),
		m_Length(0),
		m_BufSize(0),
		m_MinReallocSize(0)
	{}
public:
	virtual ~MyString()
	{
		if (m_Buf)
			FreeBuf(m_Buf);
	}
protected:
	void AddData(const Elem* other)
	{
		AddData(other,len(other));
	}
	void AddData(const Elem* other, int l)
	{
		AllocBuf(m_Length+l+1);
		memcpy(m_Buf+m_Length,other,l);
		m_Length+=l;
		m_Buf[m_Length]=0;
	}
	void AllocBuf(int newSize, bool bDeleteOld=true)
	{
		if (newSize <= m_BufSize)
			return;

		int addSize = newSize - m_BufSize;

		//minsize < minreallocsize?
		if (addSize < m_MinReallocSize)
			addSize=m_MinReallocSize;

		int oldBufSize = m_BufSize;
		m_BufSize+=addSize;
		Elem *newBuf = (Elem*)AllocateBuf(m_BufSize * sizeof(Elem));

		//nur altes kopieren wenn laenge > 0
		if (m_Length)
			memcpy(newBuf,m_Buf,m_Length+1);
		else
			newBuf[0]=0;	//sonst letztes zeichen auf \0

		//alten loeschen
		if (bDeleteOld && oldBufSize)
			FreeBuf(m_Buf);

		//zeiger umsetzen
		m_Buf=newBuf;
	}
};
