#ifndef BIGINTEGER_H__INCLUDED
#define BIGINTEGER_H__INCLUDED

#include <stdlib.h>
#include <stdio.h>

//not a real bigint impl. (uses long)
class BigInteger
{
public:
	BigInteger():m_Val(0) {}
	BigInteger(const char* val):m_Val(atol(val)) {}
	BigInteger(long val):m_Val(val) {}

public:
	const char* toString()
	{
		sprintf(buf,"%d",m_Val);
		return buf;
	}
	long toLong() const {return m_Val;}
	static BigInteger ZERO() {return BigInteger();}
	BigInteger add(const BigInteger& other){return BigInteger(toLong()+other.toLong());}
	BigInteger divide(const BigInteger& other){return BigInteger(toLong()/other.toLong());}
	BigInteger& operator = (const BigInteger& other){m_Val = other.toLong(); return *this;}
	bool operator == (const BigInteger& other){return m_Val==other.toLong(); }

private:
	char buf[30];
	long m_Val;
};

#endif BIGINTEGER_H__INCLUDED